classification
Title: compiler warnings
Type: compile error Stage: resolved
Components: Build Versions: Python 3.1, Python 3.2, Python 3.3, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: benjamin.peterson, christian.heimes, ezio.melotti, gvanrossum, jcea, matrixise, python-dev
Priority: normal Keywords:

Created on 2007-12-13 20:25 by gvanrossum, last changed 2019-05-14 18:15 by matrixise. This issue is now closed.

Messages (14)
msg58582 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2007-12-13 20:25
I figured this would be useful:

/home/guido/p25/Modules/_ctypes/libffi/src/x86/ffi.c:177: warning:
function declaration isn't a prototype
/home/guido/p25/Modules/_ctypes/libffi/src/x86/ffi.c:194: warning:
function declaration isn't a prototype
/home/guido/p25/Modules/unicodedata.c: In function `unicodedata_decimal':
/home/guido/p25/Modules/unicodedata.c:110: warning: `rc' might be used
uninitialized in this function
/home/guido/p25/Modules/unicodedata.c: In function `unicodedata_numeric':
/home/guido/p25/Modules/unicodedata.c:197: warning: `rc' might be used
uninitialized in this function
/home/guido/p25/Modules/readline.c: In function `flex_complete':
/home/guido/p25/Modules/readline.c:681: warning: implicit declaration of
function `completion_matches'
/home/guido/p25/Modules/readline.c:681: warning: return makes pointer
from integer without a cast
/home/guido/p25/Modules/cjkcodecs/_codecs_iso2022.c: In function
`iso2022processesc':
/home/guido/p25/Modules/cjkcodecs/_codecs_iso2022.c:307: warning:
`esclen' might be used uninitialized in this function
msg59783 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2008-01-12 04:26
2.96 is ancient and I don't see those warnings with 4.x series. Can I
close this bug?
msg59832 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-01-12 17:37
With a newer compiler (GCC 4.0.1 on OSX 10.5.1) I still get some warnings:

/Users/guido/p25/Modules/_ctypes/libffi/src/x86/ffi_darwin.c:220:
warning: function declaration isn’t a prototype

/Users/guido/p25/Modules/readline.c: In function ‘flex_complete’:
/Users/guido/p25/Modules/readline.c:681: warning: implicit declaration
of function ‘completion_matches’
/Users/guido/p25/Modules/readline.c:681: warning: return makes pointer
from integer without a cast

This is with GNU readline 5.2.
msg63893 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-03-18 05:06
Let's make this a catch-all bug to remind us to ensure the build is
warning-free on as many platforms as possible.
msg64346 - (view) Author: Benjamin Peterson (benjamin.peterson) * (Python committer) Date: 2008-03-22 23:29
While we're at it, see 2388.
msg70464 - (view) Author: Benjamin Peterson (benjamin.peterson) * (Python committer) Date: 2008-07-31 02:00
Is this still a problem?
msg70747 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-08-05 16:02
Let someone else review this.
msg100989 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2010-03-13 06:14
After fixing some warning on _cursesmodule.c in r78900 I found this issue and generated an updated list of all the warnings on trunk on the buildbots. When two or more buildbots had the same warnings I grouped them together, showing the url of the buildbot first and then the warnings.

http://www.python.org/dev/buildbot/builders/x86%20XP-4%20trunk
http://www.python.org/dev/buildbot/builders/x86%20XP-5%20trunk
http://www.python.org/dev/buildbot/builders/x86%20Windows7%20trunk
7>..\Objects\bufferobject.c(406) : warning C4018: '<=' : signed/unsigned mismatch
7>..\Modules\zlib\gzio.c(131) : warning C4996: 'strcpy': This function or variable may be unsafe. Consider using strcpy_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(181) : warning C4996: 'fopen': This function or variable may be unsafe. Consider using fopen_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(226) : warning C4996: 'sprintf': This function or variable may be unsafe. Consider using sprintf_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(627) : warning C4996: '_vsnprintf': This function or variable may be unsafe. Consider using _vsnprintf_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1001) : warning C4996: 'strerror': This function or variable may be unsafe. Consider using strerror_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1008) : warning C4996: 'strcpy': This function or variable may be unsafe. Consider using strcpy_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1009) : warning C4996: 'strcat': This function or variable may be unsafe. Consider using strcat_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1010) : warning C4996: 'strcat': This function or variable may be unsafe. Consider using strcat_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
21>..\Modules\_ctypes\libffi_msvc\ffi.c(113) : warning C4018: '>' : signed/unsigned mismatch
LINK : warning LNK4098: defaultlib 'MSVCRT' conflicts with use of other libs; use /NODEFAULTLIB:library

http://www.python.org/dev/buildbot/builders/x86%20Ubuntu%20trunk
http://www.python.org/dev/buildbot/builders/i386%20Ubuntu%20trunk
http://www.python.org/dev/buildbot/builders/alpha%20Debian%20trunk
http://www.python.org/dev/buildbot/builders/amd64%20gentoo%20trunk
http://www.python.org/dev/buildbot/builders/AMD64%20Ubuntu%20trunk
http://www.python.org/dev/buildbot/builders/AMD64%20Ubuntu%20wide%20trunk
/home/db3l/buildarea/trunk.bolen-ubuntu/build/./Modules/posixmodule.c:7223: warning: the use of `tmpnam_r' is dangerous, better use `mkstemp'
/home/db3l/buildarea/trunk.bolen-ubuntu/build/./Modules/posixmodule.c:7178: warning: the use of `tempnam' is dangerous, better use `mkstemp'

http://www.python.org/dev/buildbot/builders/ia64%20Ubuntu%20trunk
/home/pybot/buildarea/trunk.klose-debian-ia64/build/./Modules/posixmodule.c:7223: warning: the use of `tmpnam_r' is dangerous, better use `mkstemp'
/home/pybot/buildarea/trunk.klose-debian-ia64/build/./Modules/posixmodule.c:7178: warning: the use of `tempnam' is dangerous, better use `mkstemp'
/home/pybot/buildarea/trunk.klose-debian-ia64/build/Modules/_ctypes/libffi/src/ia64/ffi.c:401: warning: function declaration isn't a prototype

http://www.python.org/dev/buildbot/builders/sparc%20solaris10%20gcc%20trunk
/home2/buildbot/slave/trunk.loewis-sun/build/Modules/_cursesmodule.c:706: warning: implicit declaration of function `mvwchgat'
/home2/buildbot/slave/trunk.loewis-sun/build/Modules/_cursesmodule.c:710: warning: implicit declaration of function `wchgat'

http://www.python.org/dev/buildbot/builders/x86%20FreeBSD%20trunk
./Modules/posixmodule.c:7225: warning: warning: tmpnam() possibly used unsafely; consider using mkstemp()
./Modules/posixmodule.c:7178: warning: warning: tempnam() possibly used unsafely; consider using mkstemp()
/usr/home/db3l/buildarea/trunk.bolen-freebsd/build/Modules/_ssl.c:706: warning: passing arg 2 of `ASN1_item_d2i' from incompatible pointer type
/usr/home/db3l/buildarea/trunk.bolen-freebsd/build/Modules/_ssl.c:710: warning: passing arg 2 of pointer to function from incompatible pointer type
/usr/local/include/gdbm.h:85: warning: function declaration isn't a prototype
/usr/home/db3l/buildarea/trunk.bolen-freebsd/build/Modules/dlmodule.c:189: warning: initialization discards qualifiers from pointer target type
/usr/home/db3l/buildarea/trunk.bolen-freebsd/build/Modules/_ctypes/callproc.c:1411: warning: initialization discards qualifiers from pointer target type

http://www.python.org/dev/buildbot/builders/x86%20FreeBSD%207.2%20trunk
: warning: warning: tmpnam() possibly used unsafely; consider using mkstemp()
: warning: warning: tempnam() possibly used unsafely; consider using mkstemp()
/usr/home/db3l/buildarea/trunk.bolen-freebsd7/build/Modules/dlmodule.c:189: warning: initialization discards qualifiers from pointer target type
/usr/home/db3l/buildarea/trunk.bolen-freebsd7/build/Modules/_ctypes/callproc.c:1411: warning: initialization discards qualifiers from pointer target type

http://www.python.org/dev/buildbot/builders/x86%20gentoo%20trunk
Modules/posixmodule.c:7223: warning: the use of `tmpnam_r' is dangerous, better use `mkstemp'
Modules/posixmodule.c:7178: warning: the use of `tempnam' is dangerous, better use `mkstemp'
/home/buildslave/python-trunk/trunk.norwitz-x86/build/Modules/_ssl.c:706: warning: passing arg 2 of `ASN1_item_d2i' from incompatible pointer type
/home/buildslave/python-trunk/trunk.norwitz-x86/build/Modules/_ssl.c:710: warning: passing arg 2 of pointer to function from incompatible pointer type
msg100990 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2010-03-13 06:19
And this is the list for 3.x:

http://www.python.org/dev/buildbot/builders/x86%20XP-4%203.x
http://www.python.org/dev/buildbot/builders/x86%20XP-5%203.x
http://www.python.org/dev/buildbot/builders/x86%20Windows7%203.x
7>..\Modules\zlib\gzio.c(131) : warning C4996: 'strcpy': This function or variable may be unsafe. Consider using strcpy_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(181) : warning C4996: 'fopen': This function or variable may be unsafe. Consider using fopen_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(226) : warning C4996: 'sprintf': This function or variable may be unsafe. Consider using sprintf_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(627) : warning C4996: '_vsnprintf': This function or variable may be unsafe. Consider using _vsnprintf_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1001) : warning C4996: 'strerror': This function or variable may be unsafe. Consider using strerror_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1008) : warning C4996: 'strcpy': This function or variable may be unsafe. Consider using strcpy_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1009) : warning C4996: 'strcat': This function or variable may be unsafe. Consider using strcat_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
7>..\Modules\zlib\gzio.c(1010) : warning C4996: 'strcat': This function or variable may be unsafe. Consider using strcat_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.
19>..\Modules\_ctypes\libffi_msvc\ffi.c(113) : warning C4018: '>' : signed/unsigned mismatch
LINK : warning LNK4098: defaultlib 'MSVCRT' conflicts with use of other libs; use /NODEFAULTLIB:library

http://www.python.org/dev/buildbot/builders/x86%20gentoo%203.x
/home/buildslave/python-trunk/3.x.norwitz-x86/build/Modules/_ssl.c:699: warning: passing arg 2 of `ASN1_item_d2i' from incompatible pointer type
/home/buildslave/python-trunk/3.x.norwitz-x86/build/Modules/_ssl.c:704: warning: passing arg 2 of pointer to function from incompatible pointer type

http://www.python.org/dev/buildbot/builders/x86%20FreeBSD%207.2%203.x
/usr/home/db3l/buildarea/3.x.bolen-freebsd7/build/Modules/_ctypes/callproc.c:1387: warning: initialization discards qualifiers from pointer target type

http://www.python.org/dev/buildbot/builders/sparc%20solaris10%20gcc%203.x
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/sha1module.c:130:1: warning: "FF0" redefined
/usr/include/sys/termios.h:251:1: warning: this is the location of the previous definition
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/sha1module.c:131:1: warning: "FF1" redefined
/usr/include/sys/termios.h:252:1: warning: this is the location of the previous definition
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/_cursesmodule.c:716: warning: implicit declaration of function `mvwchgat'
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/_cursesmodule.c:720: warning: implicit declaration of function `wchgat'
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/_multiprocessing/semaphore.c:436: warning: int format, pid_t arg (arg 4)
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/_ctypes/callproc.c:1086: warning: implicit declaration of function `alloca'
/home2/buildbot/slave/3.x.loewis-sun/build/Modules/_ctypes/stgdict.c:486: warning: implicit declaration of function `alloca'

http://www.python.org/dev/buildbot/builders/ia64%20Ubuntu%203.x
/home/pybot/buildarea/3.x.klose-debian-ia64/build/Modules/_ctypes/libffi/src/ia64/ffi.c:401: warning: function declaration isn't a prototype

http://www.python.org/dev/buildbot/builders/x86%20FreeBSD%203.x
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ssl.c:699: warning: passing arg 2 of `ASN1_item_d2i' from incompatible pointer type
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ssl.c:704: warning: passing arg 2 of pointer to function from incompatible pointer type
/usr/local/include/gdbm.h:85: warning: function declaration isn't a prototype
/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Modules/_ctypes/callproc.c:1387: warning: initialization discards qualifiers from pointer target type

http://www.python.org/dev/buildbot/builders/i386%20Ubuntu%203.x
/scratch/pybot-buildarea/3.x.klose-ubuntu-i386/build/Modules/_pickle.c:4392:9: warning: case value '0' not in enumerated type 'enum opcode'
/scratch/pybot-buildarea/3.x.klose-ubuntu-i386/build/Modules/_csv.c:541:15: warning: operation on 'self->field' may be undefined
/scratch/pybot-buildarea/3.x.klose-ubuntu-i386/build/Modules/_csv.c:1062:14: warning: operation on 'self->rec' may be undefined
msg100992 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2010-03-13 06:50
There are also a few issues related to compiler warnings:
#7225: about other warnings in object.c, marshal.c, signalmodule.c;
#4500: about other warnings in object.c, marshal.c, main.c;
#4370: about "unknown conversion type character `z' in format" (with patch);
#2973: about the warnings in _ssl.c;
#7463: about a warning in PyDateTime_IMPORT;
#3030: about "_POSIX_C_SOURCE" being redefined on HP-UX;

#1621 might be related too, it has high priority, patches but it's still open.
msg116807 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2010-09-18 16:06
How many warnings are we now getting on the buildbots?
msg143585 - (view) Author: Jesús Cea Avión (jcea) * (Python committer) Date: 2011-09-06 05:49
I see this in quite a few of the buildbots:

(python 3.2)
./Modules/_io/iobase.c:707: warning: initialization from incompatible pointer type

Seems to affect all current versions: 2.7, 3.2 and 3.x
msg143597 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2011-09-06 11:57
New changeset f24352b0df86 by Benjamin Peterson in branch 'default':
merge 3.2 (#1616)
http://hg.python.org/cpython/rev/f24352b0df86
msg342495 - (view) Author: Stéphane Wirtel (matrixise) * (Python committer) Date: 2019-05-14 18:15
Because this issue is very long and we stopped to use the version 2.x of Gcc, and migrated to a newer verson, I close this issue. Feel free to re-open it in the future or fill a new issue.
History
Date User Action Args
2019-05-14 18:15:57matrixisesetstatus: open -> closed

nosy: + matrixise
messages: + msg342495

resolution: out of date
stage: needs patch -> resolved
2014-02-03 19:15:52BreamoreBoysetnosy: - BreamoreBoy
2011-09-06 11:57:49python-devsetnosy: + python-dev
messages: + msg143597
2011-09-06 05:49:19jceasetnosy: + jcea

messages: + msg143585
versions: + Python 3.3
2010-09-18 16:06:24BreamoreBoysetnosy: + BreamoreBoy

messages: + msg116807
versions: - Python 2.6
2010-03-13 06:50:51ezio.melottisetmessages: + msg100992
2010-03-13 06:19:26ezio.melottisetmessages: + msg100990
2010-03-13 06:14:05ezio.melottisetversions: + Python 3.1, Python 2.7, Python 3.2, - Python 2.5, Python 3.0
nosy: + ezio.melotti

messages: + msg100989

type: compile error
stage: needs patch
2008-08-05 16:02:34gvanrossumsetpriority: critical -> normal
assignee: gvanrossum ->
messages: + msg70747
2008-07-31 02:00:50benjamin.petersonsetmessages: + msg70464
2008-03-22 23:29:21benjamin.petersonsetnosy: + benjamin.peterson
messages: + msg64346
2008-03-18 05:06:30gvanrossumsetpriority: low -> critical
title: compiler warnings (gcc 2.96) -> compiler warnings
messages: + msg63893
versions: + Python 2.6, Python 3.0
2008-01-12 17:37:58gvanrossumsetstatus: pending -> open
2008-01-12 17:37:46gvanrossumsetmessages: + msg59832
2008-01-12 04:26:27christian.heimessetstatus: open -> pending
nosy: + christian.heimes
messages: + msg59783
components: + Build
2007-12-13 20:25:17gvanrossumcreate